/*
 * Device configuration
 */
package com.sea.gbgs5;

//import com.sea.config.*;
import com.sea.log.Logger;
import java.io.IOException;
import java.util.Vector;
import javax.microedition.io.Connector;
import javax.microedition.io.file.FileConnection;

/**
 *
 * @author vorisek
 */
public class Cfg {

// --------------------------------------------------
// Public configuration
// --------------------------------------------------
//public static CfgGeneral general;
//public static CfgGprs gprs;

public static String modemImei;

// --------------------------------------------------
// Private Properties
// --------------------------------------------------
public static int iLogLevel = Logger.INFO;
private static Vector listeners; // Vector of CfgListeners

// --------------------------------------------------
// Private Constants
// --------------------------------------------------
private static final String FILENAME_CFG_ROOT = "file:///A:/cfg";

// --------------------------------------------------
// Class Code
// --------------------------------------------------
static void init() {
  System.out.println("@Cfg.static init");

  checkAndCreateCfgRoot();

  // Configuration
  //general = new CfgGeneral();
  //general.read();
  //gprs = new CfgGprs();
  //gprs.read();

  modemImei = "?????????????????????????";

  listeners = new Vector();
}

/**
 * Debug printing
 */
private static void log(String line) {
  log(line, Logger.INFO);
}

/**
 * Debug printing
 */
private static void log(String line, int level) {
  if (iLogLevel >= level) {
    Logger.log("@Cfg", line);
  }

}

/**
 * Print current configuration
 */
public static void printConfiguration() {
  log("Current configuration:");
  //log("general: " + general.toString());

}

public static void addListener(CfgListener item) {
  listeners.addElement(item);
}

public static void removeListener(CfgListener item) {
  listeners.removeElement(item);
}

/**
 * Notify all listeners about configuration change
 */
public static void changed() {
  for (int i = 0; i < listeners.size(); i++) {
    ((CfgListener) listeners.elementAt(i)).cfgChanged();
  }

}


/**
 * Reset configuration of the device
 */
public static void factory() throws IOException {
  //Cfg.general.setDefault();
  //Cfg.general.write();
}


private static void checkAndCreateCfgRoot() {
  FileConnection fconn = null;
  try {
    fconn = (FileConnection) Connector.open(FILENAME_CFG_ROOT);
    if (!fconn.isDirectory()) {
      fconn.mkdir();
    }

  } catch (IOException e) {
    log("[EXCEPTION] - " + e.getMessage(), Logger.ERROR);
  } finally {
    try {
      if (null != fconn) {
        fconn.close();
      }
    } catch (IOException e) {
      System.out.println(e.getMessage());
    }
  }
}

}
